<template>
  <Dialog :title="dialogTitle" v-model="dialogVisible">
    <el-form
      ref="formRef"
      :model="formData"
      :rules="formRules"
      label-width="120px"
      v-loading="formLoading"
    >
      <el-form-item :label="t('FactoryModeling.WorkTeam.dialogTeamNameLabel')" prop="teamName">
        <el-input v-model="formData.teamName" :placeholder="t('FactoryModeling.WorkTeam.dialogTeamNamePlaceholder')" />
      </el-form-item>
      <el-form-item prop="teamType">
        <template #label>
            <span>
              {{ t('FactoryModeling.WorkTeam.dialogProcessLabel') }}
              <el-tooltip :content="t('FactoryModeling.WorkTeam.dialogProcessTooltip')" placement="top">
                <Icon icon="ep:question-filled" />
              </el-tooltip>
            </span>
        </template>
        <el-radio-group v-model="formData.teamType">
          <el-radio
            v-for="dict in getStrDictOptions(DICT_TYPE.MES_ORG_TYPE)"
            :key="dict.value"
            :label="dict.value"
          >
            {{ dict.label }}
          </el-radio>
        </el-radio-group>
      </el-form-item>
      <el-form-item prop="groupType">
        <template #label>
            <span>
              {{ t('FactoryModeling.WorkTeam.dialogGroupTypeLabel') }}
              <el-tooltip :content="t('FactoryModeling.WorkTeam.dialogGroupTypeTooltip')" placement="top">
                <Icon icon="ep:question-filled" />
              </el-tooltip>
            </span>
        </template>
        <el-radio-group v-model="formData.groupType">
          <el-radio
            v-for="dict in getStrDictOptions(DICT_TYPE.MES_GROUP_TYPE)"
            :key="dict.value"
            :label="dict.value"
          >
            {{ dict.label }}
          </el-radio>
        </el-radio-group>
      </el-form-item>
      <el-form-item  :label="t('FactoryModeling.WorkTeam.dialogWorkTimeLabel')" prop="工作时间">
        <el-time-picker
          v-model="formData.dateRange"
          is-range
          value-format="x"
          :range-separator="t('FactoryModeling.WorkTeam.dialogWorkTimeRangeSeparator')"
          :start-placeholder="t('FactoryModeling.WorkTeam.dialogWorkTimeStartPlaceholder')"
          :end-placeholder="t('FactoryModeling.WorkTeam.dialogWorkTimeEndPlaceholder')"
        />
      </el-form-item>
      <el-form-item :label="t('FactoryModeling.WorkTeam.dialogRemarkLabel')" prop="remark">
        <el-input v-model="formData.remark" :placeholder="t('FactoryModeling.WorkTeam.dialogRemarkPlaceholder')" type="textarea"/>
      </el-form-item>
      <el-form-item :label="t('FactoryModeling.WorkTeam.dialogEnableLabel')" prop="isEnable">
        <el-radio-group v-model="formData.isEnable">
          <el-radio
            v-for="dict in getBoolDictOptions(DICT_TYPE.INFRA_BOOLEAN_STRING)"
            :key="dict.value"
            :label="dict.value"
          >
            {{ dict.label }}
          </el-radio>
        </el-radio-group>
      </el-form-item>
    </el-form>
    <template #footer>
      <el-button @click="submitForm" type="primary" :disabled="formLoading">{{ t('common.ok') }}</el-button>
      <el-button @click="dialogVisible = false">{{ t('common.cancel') }}</el-button>
    </template>
  </Dialog>
</template>
<script setup lang="ts">
import {getStrDictOptions, DICT_TYPE, getBoolDictOptions} from '@/utils/dict'
import { WorkTeamApi, WorkTeamVO } from '@/api/mes/workteam'

/** 生产班组 表单 */
defineOptions({ name: 'WorkTeamForm' })

const { t } = useI18n() // 国际化
const message = useMessage() // 消息弹窗

const dialogVisible = ref(false) // 弹窗的是否展示
const dialogTitle = ref('') // 弹窗的标题
const formLoading = ref(false) // 表单的加载中：1）修改时的数据加载；2）提交的按钮禁用
const formType = ref('') // 表单的类型：create - 新增；update - 修改
const formData = ref({
  id: undefined,
  teamName: undefined,
  teamLeaderId: undefined,
  teamType: undefined,
  groupType: undefined,
  startTime: undefined,
  endTime: undefined,
  remark: undefined,
  isEnable: undefined,
  dateRange:[]
})

const formRules = reactive({
  teamType: [{ required: true, message: t('FactoryModeling.WorkTeam.validatorProcessRequired'), trigger: 'blur' }],
  groupType: [{ required: true, message: t('FactoryModeling.WorkTeam.validatorGroupTypeRequired'), trigger: 'blur' }],
  isEnable: [{ required: true, message: t('FactoryModeling.WorkTeam.validatorEnableRequired'), trigger: 'blur' }],
  teamName: [{ required: true, message: t('FactoryModeling.WorkTeam.validatorTeamNameRequired'), trigger: 'blur' }]
})
const formRef = ref() // 表单 Ref

/** 打开弹窗 */
const open = async (type: string, id?: number) => {
  dialogVisible.value = true
  dialogTitle.value = t('action.' + type)
  formType.value = type
  resetForm()
  formData.value.groupType = '1'
  formData.value.teamType = 'chengxing'
  formData.value.isEnable = true
  formData.value.dateRange=[new Date(), new Date()]
  // 修改时，设置数据
  if (id) {
    formLoading.value = true
    try {
      formData.value = await WorkTeamApi.getWorkTeam(id)
      formData.value.dateRange  = [formData.value.startTime, formData.value.endTime]
    } finally {
      formLoading.value = false
    }
  }
}
defineExpose({ open }) // 提供 open 方法，用于打开弹窗

/** 提交表单 */
const emit = defineEmits(['success']) // 定义 success 事件，用于操作成功后的回调
const submitForm = async () => {
  // 校验表单
  await formRef.value.validate()
  // 提交请求
  formLoading.value = true
  try {
    formData.value.startTime =  formData.value.dateRange[0]
    formData.value.endTime =  formData.value.dateRange[1]
    const data = formData.value as unknown as WorkTeamVO
    if (formType.value === 'create') {
      await WorkTeamApi.createWorkTeam(data)
      message.success(t('common.createSuccess'))
    } else {
      await WorkTeamApi.updateWorkTeam(data)
      message.success(t('common.updateSuccess'))
    }
    dialogVisible.value = false
    // 发送操作成功的事件
    emit('success')
  } finally {
    formLoading.value = false
  }
}

/** 重置表单 */
const resetForm = () => {
  formData.value = {
    id: undefined,
    teamName: undefined,
    teamLeaderId: undefined,
    teamType: undefined,
    remark: undefined,
    isEnable: undefined,
  }
  formRef.value?.resetFields()
}
</script>
